diff a/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/AOTClassLinkingVerification.java b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/AOTClassLinkingVerification.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/AOTClassLinkingVerification.java
@@ -0,0 +1,201 @@
+/*
+ * Copyright (c) 2023, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+/*
+ * @test In Leyden repo, classes that are linked during the assembly phase can
+ *       skip verification constraint checks. See JDK-8317269.
+ *       NOTE: this feature is not included when JDK-8315737 is upstreamed to the mainline.
+ * @requires vm.cds
+ * @requires vm.cds.supports.aot.class.linking
+ * @summary Test for verification of classes that are aot-linked
+ * @library /test/jdk/lib/testlibrary
+ *          /test/lib
+ *          /test/hotspot/jtreg/runtime/cds/appcds
+ *          /test/hotspot/jtreg/runtime/cds/appcds/test-classes
+ * @build GoodOldClass BadOldClass BadOldClass2 BadNewClass BadNewClass2
+ * @build AOTClassLinkingVerification
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar WhiteBox.jar jdk.test.whitebox.WhiteBox
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app1.jar
+ *                 AOTClassLinkingVerificationApp
+ *                 Unlinked UnlinkedSuper
+ *                 BadOldClass
+ *                 BadOldClass2
+ *                 BadNewClass
+ *                 BadNewClass2
+ *                 GoodOldClass Vehicle Car
+ *                 Util
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app2.jar
+ *                 UnlinkedSub
+ *                 Foo NotFoo
+ * @run driver AOTClassLinkingVerification
+ */
+
+import java.io.File;
+import java.lang.invoke.MethodHandles;
+import jdk.test.lib.helpers.ClassFileInstaller;
+import jdk.test.whitebox.WhiteBox;
+
+public class AOTClassLinkingVerification {
+    static final String app1Jar = ClassFileInstaller.getJarPath("app1.jar");
+    static final String app2Jar = ClassFileInstaller.getJarPath("app2.jar");
+    static final String wbJar = TestCommon.getTestJar("WhiteBox.jar");
+    static final String bootAppendWhiteBox = "-Xbootclasspath/a:" + wbJar;
+    static final String mainClass = AOTClassLinkingVerificationApp.class.getName();
+
+    public static void main(String[] args) throws Exception {
+        // Dump without app2.jar so:
+        //  - Unlinked can be resolved, but UnlinkedSuper UnlinkedSub cannot be resolved,
+        //    so Unlinked cannot be verified at dump time.
+        //  - BadOldClass2 can be resolved, but Foo and NotFoo cannot be resolved,
+        //    so BadOldClass2 cannot be verified at dump time.
+        //  - BadNewClass2 can be resolved, but Foo and NotFoo cannot be resolved,
+        //    so BadNewClass2 cannot be verified at dump time.
+        TestCommon.testDump(app1Jar, TestCommon.list("Unlinked",
+                                                     "BadOldClass",
+                                                     "BadOldClass2",
+                                                     "BadNewClass",
+                                                     "BadNewClass2",
+                                                     "GoodOldClass"),
+                            bootAppendWhiteBox,
+                            "-XX:+AOTClassLinking",
+                            "-Xlog:cds+class=debug");
+
+        TestCommon.run("-cp", app1Jar + File.pathSeparator + app2Jar,
+                       "-XX:+UnlockDiagnosticVMOptions",
+                       "-XX:+WhiteBoxAPI",
+                       bootAppendWhiteBox,
+                       "AOTClassLinkingVerificationApp", app1Jar)
+            .assertNormalExit();
+    }
+}
+
+class AOTClassLinkingVerificationApp {
+    static WhiteBox wb = WhiteBox.getWhiteBox();
+    static ClassLoader classLoader = AOTClassLinkingVerificationApp.class.getClassLoader();
+    static File app1Jar;
+
+    public static void main(String[] args) throws Exception {
+        app1Jar = new File(args[0]);
+        assertNotShared(UnlinkedSub.class);
+        assertShared(UnlinkedSuper.class);
+        assertShared(Unlinked.class);
+        assertNotShared(Foo.class);
+        assertNotShared(NotFoo.class);
+        String s = Unlinked.doit();
+        if (!s.equals("heyhey")) {
+            throw new RuntimeException("Unlinked.doit() returns wrong result: " + s);
+        }
+
+        Class cls_BadOldClass = Class.forName("BadOldClass", false, classLoader);
+        assertShared(cls_BadOldClass);
+        try {
+            cls_BadOldClass.newInstance();
+            throw new RuntimeException("BadOldClass cannot be verified");
+        } catch (VerifyError expected) {}
+
+        Class cls_BadOldClass2 = Class.forName("BadOldClass2", false, classLoader);
+        assertShared(cls_BadOldClass2);
+        try {
+            cls_BadOldClass2.newInstance();
+            throw new RuntimeException("BadOldClass2 cannot be verified");
+        } catch (VerifyError expected) {}
+
+        Class cls_BadNewClass = Class.forName("BadNewClass", false, classLoader);
+        assertShared(cls_BadNewClass);
+        try {
+            cls_BadNewClass.newInstance();
+            throw new RuntimeException("BadNewClass cannot be verified");
+        } catch (VerifyError expected) {}
+
+        Class cls_BadNewClass2 = Class.forName("BadNewClass2", false, classLoader);
+        assertShared(cls_BadNewClass2);
+        try {
+            cls_BadNewClass2.newInstance();
+            throw new RuntimeException("BadNewClass2 cannot be verified");
+        } catch (VerifyError expected) {}
+
+
+        // Although Vehicle and Car are not specified in the classlist, they are archived as
+        // they were used during dumptime verification of GoodOldClass
+        assertAlreadyLoaded("Vehicle");
+        assertAlreadyLoaded("Car");
+        assertAlreadyLoaded("GoodOldClass");
+
+        assertShared(GoodOldClass.class);
+        assertShared(Vehicle.class);
+        assertShared(Car.class);
+
+        GoodOldClass.doit(); // Should not fail
+    }
+
+    static void assertShared(Class c) {
+        if (!wb.isSharedClass(c)) {
+            throw new RuntimeException("wb.isSharedClass(" + c.getName() + ") should be true");
+        }
+    }
+
+    static void assertNotShared(Class c) {
+        if (wb.isSharedClass(c)) {
+            throw new RuntimeException("wb.isSharedClass(" + c.getName() + ") should be false");
+        }
+    }
+
+    static void assertAlreadyLoaded(String className) throws Exception {
+        byte[] data = Util.getClassFileFromJar(app1Jar, className);
+        try {
+            MethodHandles.lookup().defineClass(data);
+        } catch (LinkageError e) {
+            if (e.getMessage().contains("duplicate class definition for " + className)) {
+                return;
+            } else {
+                throw e;
+            }
+        }
+        throw new RuntimeException(className + " must have already been loaded");
+    }
+}
+
+
+class Unlinked {
+    static String doit() {
+        UnlinkedSuper sup = new UnlinkedSub();
+        return sup.doit();
+    }
+}
+
+abstract class UnlinkedSuper {
+    abstract String doit();
+}
+
+class UnlinkedSub extends UnlinkedSuper {
+    String doit() {
+        return "heyhey";
+    }
+}
+
+class Foo {}
+class NotFoo {}
+
+class Vehicle {}
+class Car extends Vehicle {}
diff a/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadNewClass.jasm b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadNewClass.jasm
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadNewClass.jasm
@@ -0,0 +1,38 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * ORACLE PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
+ */
+
+// When -XX:+PreloadSharedClasses is enabled, this class will be
+// archived in the unlinked state. When we try to use this class
+// at runtime, a VerifyError should be thrown.
+
+super public class BadNewClass
+	version 49:0
+{
+
+
+public Method "<init>":"()V"
+	stack 1 locals 1
+{
+		aload_0;
+		invokespecial	Method java/lang/Object."<init>":"()V";
+		return;
+}
+
+    /*
+     * The following method tries to return an Object as a String.
+     * Verifier should fail.
+     */
+public Method doit:"()Ljava/lang/String;"
+	stack 2 locals 1
+{
+                new	class java/lang/Object;
+		dup;
+		invokespecial	Method java/lang/Object."<init>":"()V";
+		astore_0;
+		aload_0;
+		areturn;   // tries to return an Object as a String
+}
+
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadNewClass2.jasm b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadNewClass2.jasm
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadNewClass2.jasm
@@ -0,0 +1,38 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * ORACLE PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
+ */
+
+// When -XX:+PreloadSharedClasses is enabled, this class will be
+// archived in the unlinked state. When we try to use this class
+// at runtime, a VerifyError should be thrown.
+
+super public class BadNewClass2
+	version 52:0
+{
+
+
+public Method "<init>":"()V"
+	stack 1 locals 1
+{
+		aload_0;
+		invokespecial	Method java/lang/Object."<init>":"()V";
+		return;
+}
+
+    /*
+     * The following method tries to return a NotFoo as a Foo.
+     * Verifier should fail.
+     */
+public Method doit:"()LFoo;"
+	stack 2 locals 1
+{
+                new	class NotFoo;
+		dup;
+		invokespecial	Method NotFoo."<init>":"()V";
+		astore_0;
+		aload_0;
+		areturn;   // tries to return a NotFoo as a Foo
+}
+
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadOldClass.jasm b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadOldClass.jasm
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadOldClass.jasm
@@ -0,0 +1,38 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * ORACLE PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
+ */
+
+// When -XX:+PreloadSharedClasses is enabled, this class will be
+// archived in the unlinked state. When we try to use this class
+// at runtime, a VerifyError should be thrown.
+
+super public class BadOldClass
+	version 49:0
+{
+
+
+public Method "<init>":"()V"
+	stack 1 locals 1
+{
+		aload_0;
+		invokespecial	Method java/lang/Object."<init>":"()V";
+		return;
+}
+
+    /*
+     * The following method tries to return an Object as a String.
+     * Verifier should fail.
+     */
+public Method doit:"()Ljava/lang/String;"
+	stack 2 locals 1
+{
+                new	class java/lang/Object;
+		dup;
+		invokespecial	Method java/lang/Object."<init>":"()V";
+		astore_0;
+		aload_0;
+		areturn;   // tries to return an Object as a String
+}
+
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadOldClass2.jasm b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadOldClass2.jasm
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/BadOldClass2.jasm
@@ -0,0 +1,38 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * ORACLE PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
+ */
+
+// When -XX:+PreloadSharedClasses is enabled, this class will be
+// archived in the unlinked state. When we try to use this class
+// at runtime, a VerifyError should be thrown.
+
+super public class BadOldClass2
+	version 49:0
+{
+
+
+public Method "<init>":"()V"
+	stack 1 locals 1
+{
+		aload_0;
+		invokespecial	Method java/lang/Object."<init>":"()V";
+		return;
+}
+
+    /*
+     * The following method tries to return a NotFoo as a Foo.
+     * Verifier should fail.
+     */
+public Method doit:"()LFoo;"
+	stack 2 locals 1
+{
+                new	class NotFoo;
+		dup;
+		invokespecial	Method NotFoo."<init>":"()V";
+		astore_0;
+		aload_0;
+		areturn;   // tries to return a NotFoo as a Foo
+}
+
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/GoodOldClass.jasm b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/GoodOldClass.jasm
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/aotClassLinking/GoodOldClass.jasm
@@ -0,0 +1,35 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * ORACLE PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
+ */
+
+// When -XX:+PreloadSharedClasses is enabled, this class will be
+// archived in the unlinked state. When we try to use this class
+// at runtime, a VerifyError should be thrown.
+
+super public class GoodOldClass
+	version 49:0
+{
+
+
+public Method "<init>":"()V"
+	stack 1 locals 1
+{
+		aload_0;
+		invokespecial	Method java/lang/Object."<init>":"()V";
+		return;
+}
+
+
+public static Method doit:"()LVehicle;"
+	stack 2 locals 1
+{
+                new	class Car;
+		dup;
+		invokespecial	Method Car."<init>":"()V";
+		astore_0;
+		aload_0;
+		areturn;   // tries to return a Car as a Vehicle
+}
+
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/applications/HelidonQuickStartSE.java b/test/hotspot/jtreg/runtime/cds/appcds/applications/HelidonQuickStartSE.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/applications/HelidonQuickStartSE.java
@@ -0,0 +1,133 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+import java.io.File;
+import java.nio.file.Path;
+import java.util.Map;
+import jdk.test.lib.StringArrayUtils;
+import jdk.test.lib.artifacts.Artifact;
+import jdk.test.lib.artifacts.ArtifactResolver;
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.process.OutputAnalyzer;
+
+/*
+ * @test id=static
+ * @key external-dep
+ * @requires vm.cds
+ * @summary run HelidonQuickStartSE with the classic static archive workflow
+ * @library /test/lib
+ * @run driver/timeout=120 HelidonQuickStartSE STATIC
+ */
+
+/*
+ * @test id=dynamic
+ * @key external-dep
+ * @requires vm.cds
+ * @summary run HelidonQuickStartSE with the classic dynamic archive workflow
+ * @library /test/lib
+ * @run driver/timeout=120 HelidonQuickStartSE DYNAMIC
+ */
+
+/*
+ * @test id=leyden
+ * @key external-dep
+ * @requires vm.cds
+ * @requires vm.cds.write.archived.java.heap
+ * @summary un HelidonQuickStartSE with the Leyden workflow
+ * @library /test/lib
+ * @run driver/timeout=120 HelidonQuickStartSE LEYDEN
+ */
+
+// Test CDS with the example program in https://helidon.io/docs/v4/se/guides/quickstart
+//
+// NOTE: if you have not set up an artifactory, you can create helidon-quickstart-se-4.0.7.zip by:
+//
+// - Make a clone of https://github.com/openjdk/leyden/tree/premain
+// - Change to the directory test/hotspot/jtreg/premain/helidon-quickstart-se
+// - Edit the Makefile and ../lib/DemoSupport.gmk as necessary
+// - Run the command "make artifact"
+//
+// Then, you can add the following to your jtreg command-line to run the test cases in this directory:
+// -vmoption:-Djdk.test.lib.artifacts.helidon-quickstart-se=/my/repo/test/hotspot/jtreg/premain/helidon-quickstart-se/helidon-quickstart-se
+
+@Artifact(organization = "io.helidon", name = "helidon-quickstart-se", revision = "4.0.7", extension = "zip")
+public class HelidonQuickStartSE {
+    public static void main(String args[]) throws Exception {
+        String cp = getArtifact();
+        HelidonQuickStartSETester tester = new HelidonQuickStartSETester(cp);
+        tester.run(args);
+        System.out.println(cp);
+    }
+
+    private static String getArtifact() throws Exception {
+        String sep = File.separator;
+        Map<String, Path> artifacts = ArtifactResolver.resolve(HelidonQuickStartSE.class);
+        Path path = artifacts.get("io.helidon.helidon-quickstart-se-4.0.7");
+        return path.toString() + sep + "target" + sep + "helidon-quickstart-se.jar";
+    }
+
+    static class HelidonQuickStartSETester extends CDSAppTester {
+        String cp;
+
+        HelidonQuickStartSETester(String cp) {
+            super("HelidonQuickStartSE");
+            this.cp = cp;
+        }
+
+        @Override
+        public String[] vmArgs(RunMode runMode) {
+            return new String[] {
+                "-DautoQuit=true",
+                "-Dserver.port=0", // use system-assigned port
+
+                // This program may run very slowly in debug builds if VerifyDependencies is enabled.
+                "-XX:+IgnoreUnrecognizedVMOptions", "-XX:-VerifyDependencies",
+            };
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return cp;
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            String cmdLine[] = new String[] {
+                "io.helidon.examples.quickstart.se.Main", 
+            };
+
+            if (runMode.isProductionRun()) {
+                cmdLine = StringArrayUtils.concat("-Xlog:scc=error", cmdLine);
+            }
+            return cmdLine;
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) {
+            if (!runMode.isStaticDump()) {
+                out.shouldContain("Booted and returned in ");
+            }
+        }
+    }
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/applications/JavacBench.java b/test/hotspot/jtreg/runtime/cds/appcds/applications/JavacBench.java
--- a/test/hotspot/jtreg/runtime/cds/appcds/applications/JavacBench.java
+++ b/test/hotspot/jtreg/runtime/cds/appcds/applications/JavacBench.java
@@ -36,12 +36,22 @@
  * @requires vm.cds
  * @library /test/lib
  * @run driver JavacBench DYNAMIC
  */
 
+/*
+ * @test id=leyden
+ * @summary Run JavacBenchApp with Leyden workflow
+ * @requires vm.cds
+ * @requires vm.cds.write.archived.java.heap
+ * @library /test/lib
+ * @run driver JavacBench LEYDEN
+ */
+
 import jdk.test.lib.cds.CDSAppTester;
 import jdk.test.lib.helpers.ClassFileInstaller;
+import jdk.test.lib.process.OutputAnalyzer;
 
 public class JavacBench {
     static String mainClass = JavacBenchApp.class.getName();
     static String appJar;
 
diff a/test/hotspot/jtreg/runtime/cds/appcds/applications/MicronautFirstApp.java b/test/hotspot/jtreg/runtime/cds/appcds/applications/MicronautFirstApp.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/applications/MicronautFirstApp.java
@@ -0,0 +1,132 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+import java.io.File;
+import java.nio.file.Path;
+import java.util.Map;
+import jdk.test.lib.StringArrayUtils;
+import jdk.test.lib.artifacts.Artifact;
+import jdk.test.lib.artifacts.ArtifactResolver;
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.process.OutputAnalyzer;
+
+/*
+ * @test id=static
+ * @key external-dep
+ * @requires vm.cds
+ * @summary run MicronautFirstApp with the classic static archive workflow
+ * @library /test/lib
+ * @run driver/timeout=120 MicronautFirstApp STATIC
+ */
+
+/*
+ * @test id=dynamic
+ * @key external-dep
+ * @requires vm.cds
+ * @summary run MicronautFirstApp with the classic dynamic archive workflow
+ * @library /test/lib
+ * @run driver/timeout=120 MicronautFirstApp DYNAMIC
+ */
+
+/*
+ * @test id=leyden
+ * @key external-dep
+ * @requires vm.cds
+ * @requires vm.cds.write.archived.java.heap
+ * @summary un MicronautFirstApp with the Leyden workflow
+ * @library /test/lib
+ * @run driver/timeout=120 MicronautFirstApp LEYDEN
+ */
+
+// Test CDS with the example program in https://guides.micronaut.io/latest/creating-your-first-micronaut-app-maven-java.html
+//
+// NOTE: if you have not set up an artifactory, you can create micronaut-first-app-1.0.0.zip
+//
+// - Make a clone of https://github.com/openjdk/leyden/tree/premain
+// - Change to the directory test/hotspot/jtreg/premain/micronaut-first-app
+// - Edit the Makefile and ../lib/DemoSupport.gmk as necessary
+// - Run the command "make artifact"
+//
+// Then, you can add the following to your jtreg command-line to run the test cases in this directory:
+// -vmoption:-Djdk.test.lib.artifacts.micronaut-first-app=/my/repo/test/hotspot/jtreg/premain/micronaut-first-app/download/target/
+
+@Artifact(organization = "io.micronaut", name = "micronaut-first-app", revision = "1.0.0", extension = "zip")
+public class MicronautFirstApp {
+    public static void main(String args[]) throws Exception {
+        String cp = getArtifact();
+        MicronautFirstAppTester tester = new MicronautFirstAppTester(cp);
+        tester.run(args);
+        System.out.println(cp);
+    }
+
+    private static String getArtifact() throws Exception {
+        Map<String, Path> artifacts = ArtifactResolver.resolve(MicronautFirstApp.class);
+        Path path = artifacts.get("io.micronaut.micronaut-first-app-1.0.0");
+        return path.toString() + File.separator + "default-0.1.jar";
+    }
+
+    static class MicronautFirstAppTester extends CDSAppTester {
+        String cp;
+
+        MicronautFirstAppTester(String cp) {
+            super("MicronautFirstApp");
+            this.cp = cp;
+        }
+
+        @Override
+        public String[] vmArgs(RunMode runMode) {
+            return new String[] {
+                "-DautoQuit=true",
+                "-Dmicronaut.server.port=0", // use system-assigned port
+
+                // This program may run very slowly in debug builds if VerifyDependencies is enabled.
+                "-XX:+IgnoreUnrecognizedVMOptions", "-XX:-VerifyDependencies",
+            };
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return cp;
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            String cmdLine[] = new String[] {
+                "example.micronaut.Application", 
+            };
+
+            if (runMode.isProductionRun()) {
+                cmdLine = StringArrayUtils.concat("-Xlog:scc=error", cmdLine);
+            }
+            return cmdLine;
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) {
+            if (!runMode.isStaticDump()) {
+                out.shouldContain("Booted and returned in ");
+            }
+        }
+    }
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/applications/QuarkusGettingStarted.java b/test/hotspot/jtreg/runtime/cds/appcds/applications/QuarkusGettingStarted.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/applications/QuarkusGettingStarted.java
@@ -0,0 +1,132 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+import java.io.File;
+import java.nio.file.Path;
+import java.util.Map;
+import jdk.test.lib.StringArrayUtils;
+import jdk.test.lib.artifacts.Artifact;
+import jdk.test.lib.artifacts.ArtifactResolver;
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.process.OutputAnalyzer;
+
+/*
+ * @test id=static
+ * @key external-dep
+ * @requires vm.cds
+ * @summary run QuarkusGettingStarted with the classic static archive workflow
+ * @library /test/lib
+ * @run driver/timeout=120 QuarkusGettingStarted STATIC
+ */
+
+/*
+ * @test id=dynamic
+ * @key external-dep
+ * @requires vm.cds
+ * @summary run QuarkusGettingStarted with the classic dynamic archive workflow
+ * @library /test/lib
+ * @run driver/timeout=120 QuarkusGettingStarted DYNAMIC
+ */
+
+/*
+ * @test id=leyden
+ * @key external-dep
+ * @requires vm.cds
+ * @requires vm.cds.write.archived.java.heap
+ * @summary un QuarkusGettingStarted with the Leyden workflow
+ * @library /test/lib
+ * @run driver/timeout=120 QuarkusGettingStarted LEYDEN
+ */
+
+// Test CDS with the example program in https://quarkus.io/guides/getting-started
+//
+// NOTE: if you have not set up an artifactory, you can create quarkus-getting-started-1.0.0b.zip by:
+//
+// - Make a clone of https://github.com/openjdk/leyden/tree/premain
+// - Change to the directory test/hotspot/jtreg/premain/quarkus-getting-started
+// - Edit the Makefile and ../lib/DemoSupport.gmk as necessary
+// - Run the command "make artifact"
+//
+// Then, you can add the following to your jtreg command-line to run the test cases in this directory:
+// -vmoption:-Djdk.test.lib.artifacts.quarkus-getting-started=/my/repo/test/hotspot/jtreg/premain/quarkus-getting-started/getting-started/target
+
+@Artifact(organization = "io.quarkus", name = "quarkus-getting-started", revision = "1.0.0b", extension = "zip")
+public class QuarkusGettingStarted {
+    public static void main(String args[]) throws Exception {
+        String cp = getArtifact();
+        QuarkusGettingStartedTester tester = new QuarkusGettingStartedTester(cp);
+        tester.run(args);
+        System.out.println(cp);
+    }
+
+    private static String getArtifact() throws Exception {
+        Map<String, Path> artifacts = ArtifactResolver.resolve(QuarkusGettingStarted.class);
+        Path path = artifacts.get("io.quarkus.quarkus-getting-started-1.0.0b");
+        return path.toString() + File.separator + "getting-started-1.0.0-SNAPSHOT-runner.jar";
+    }
+
+    static class QuarkusGettingStartedTester extends CDSAppTester {
+        String cp;
+
+        QuarkusGettingStartedTester(String cp) {
+            super("QuarkusGettingStarted");
+            this.cp = cp;
+        }
+
+        @Override
+        public String[] vmArgs(RunMode runMode) {
+            return new String[] {
+                "-DautoQuit=true",
+                "-Dquarkus.http.port=0", // use system-assigned port
+
+                // This program may run very slowly in debug builds if VerifyDependencies is enabled.
+                "-XX:+IgnoreUnrecognizedVMOptions", "-XX:-VerifyDependencies",
+            };
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return cp;
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            String cmdLine[] = new String[] {
+                "Main", 
+            };
+
+            if (runMode.isProductionRun()) {
+                cmdLine = StringArrayUtils.concat("-Xlog:scc=error", cmdLine);
+            }
+            return cmdLine;
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) {
+            if (!runMode.isStaticDump()) {
+                out.shouldContain("Booted and returned in ");
+            }
+        }
+    }
+}
